clang-tools 6.0.0

Public Member Functions | List of all members
clang::tidy::android::CloexecInotifyInit1Check Class Reference

Finds code that uses inotify_init1() without using the IN_CLOEXEC flag. More...

`#include <CloexecInotifyInit1Check.h>`

Inheritance diagram for clang::tidy::android::CloexecInotifyInit1Check:
[legend]
Collaboration diagram for clang::tidy::android::CloexecInotifyInit1Check:
[legend]

## Public Member Functions
| CloexecInotifyInit1Check (StringRef Name, ClangTidyContext *Context)
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Override this to register AST matchers with `Finder`. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
Public Member Functions inherited from clang::tidy::android::CloexecCheck
| CloexecCheck (StringRef Name, ClangTidyContext *Context)
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (CompilerInstance &Compiler)
| Override this to register `PPCallbacks` with `Compiler`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...
virtual void | storeOptions (ClangTidyOptions::OptionMap &Options)
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::android::CloexecCheck
void | registerMatchersImpl (ast_matchers::MatchFinder *Finder, ast_matchers::internal::Matcher< FunctionDecl > Function)
void | insertMacroFlag (const ast_matchers::MatchFinder::MatchResult &Result, StringRef MacroFlag, int ArgPos)
| Currently, we have three types of fixes. More...
void | replaceFunc (const ast_matchers::MatchFinder::MatchResult &Result, StringRef WarningMsg, StringRef FixMsg)
| Type2 is to replace the API to another function that has required the ability. More...
void | insertStringFlag (const ast_matchers::MatchFinder::MatchResult &Result, const char Mode, const int ArgPos)
| Type3 is also to add a flag to the corresponding argument, but this time, the flag is some string and each char represents a mode rather than a macro. More...
StringRef | getSpellingArg (const ast_matchers::MatchFinder::MatchResult &Result, int N) const
| Helper function to get the spelling of a particular argument. More...
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options
Static Protected Attributes inherited from clang::tidy::android::CloexecCheck
static const char * | FuncDeclBindingStr = "funcDecl"
| Binding name of the FuncDecl of a function call. More...
static const char * | FuncBindingStr ="func"
| Binding name of the function call expression. More...

## Detailed Description

Finds code that uses inotify_init1() without using the IN_CLOEXEC flag.

For the user-facing documentation see: http://clang.llvm.org/extra/clang-tidy/checks/android-cloexec-inotify-init1.html

Definition at line 23 of file CloexecInotifyInit1Check.h.

## Constructor & Destructor Documentation

## ◆ CloexecInotifyInit1Check()

clang::tidy::android::CloexecInotifyInit1Check::CloexecInotifyInit1Check | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |
| inline

Definition at line 25 of file CloexecInotifyInit1Check.h.

References registerMatchers().

## Member Function Documentation

## ◆ check()

void clang::tidy::android::CloexecInotifyInit1Check::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 27 of file CloexecInotifyInit1Check.cpp.

## ◆ registerMatchers()

void clang::tidy::android::CloexecInotifyInit1Check::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Override this to register AST matchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 21 of file CloexecInotifyInit1Check.cpp.

Referenced by CloexecInotifyInit1Check().

The documentation for this class was generated from the following files:

- CloexecInotifyInit1Check.h
- CloexecInotifyInit1Check.cpp